// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_CONTAINERS_PRIORITY_QUEUE_H
#define FENNEC_TEST_CONTAINERS_PRIORITY_QUEUE_H

#include "../../test.h"

#include <cstdlib>
#include <fennec/containers/priority_queue.h>
#include <fennec/containers/sequence.h>

namespace fennec::test
{

	inline void fennec_test_containers_priority_queue() {

		using type_t = decltype(rand());
		sequence<type_t> ref;
		priority_queue<type_t> test;

		size_t n = 50;
		for (size_t i = 0; i < n; ++i) {
			type_t v = rand();
			test.push(v);
			ref.insert(v);
		}

		fennec_test_run(test.size(), n);

		for (type_t x : ref) {
			assert(x == test.front(), "Failed Priority Queue Test!");
			test.pop();
		}

		std::cout << "passed" << std::endl;
	}

}

#endif // FENNEC_TEST_CONTAINERS_PRIORITY_QUEUE_H
